'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Menu = function (_Component) {
  _inherits(Menu, _Component);

  function Menu() {
    _classCallCheck(this, Menu);

    return _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).apply(this, arguments));
  }

  _createClass(Menu, [{
    key: 'cloneChildren',
    value: function cloneChildren() {
      var _props = this.props,
          children = _props.children,
          hoverable = _props.hoverable,
          rippable = _props.rippable,
          indentItemsLeft = _props.indentItemsLeft,
          indentItemsRight = _props.indentItemsRight,
          _props$childClassName = _props.childClassNames,
          childClassNames = _props$childClassName === undefined ? [] : _props$childClassName;

      var childrenArray = _react2.default.Children.toArray(children);

      return childrenArray.map(function (child, key) {
        return _react2.default.cloneElement(child, {
          key: key,
          hoverable: hoverable,
          rippable: rippable,
          indentLeft: !!indentItemsLeft,
          indentRight: !!indentItemsRight,
          className: childClassNames[key]
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          _props2$zDepth = _props2.zDepth,
          zDepth = _props2$zDepth === undefined ? 8 : _props2$zDepth,
          type = _props2.type,
          color = _props2.color,
          style = _props2.style;


      return _react2.default.createElement(
        _Paper2.default,
        {
          style: style,
          type: type,
          zDepth: zDepth,
          color: color
        },
        _react2.default.createElement(
          'ul',
          { className: 'menu' },
          this.cloneChildren()
        )
      );
    }
  }]);

  return Menu;
}(_react.Component);

Menu.propTypes = {
  zDepth: _propTypes2.default.number,
  type: _propTypes2.default.string,
  color: _propTypes2.default.string,
  style: _propTypes2.default.object,
  children: _propTypes2.default.node,
  hoverable: _propTypes2.default.bool,
  rippable: _propTypes2.default.bool,
  indentItemsLeft: _propTypes2.default.bool,
  indentItemsRight: _propTypes2.default.bool,
  childClassNames: _propTypes2.default.array
};

exports.default = Menu;